<?php
/*
  Laskuhari Payment Gateway for osCommerce
  Version 0.1 BETA
*/

  class laskuhari {
    var $code, $title, $description, $enabled;

    function laskuhari() {
      global $order;

      $this->code = 'laskuhari';
      $this->title = "Laskutus";
      $this->description = "Aktivoi laskulla maksaminen";
      $this->enabled = defined('MODULE_PAYMENT_LASKUHARI_STATUS') && (MODULE_PAYMENT_LASKUHARI_STATUS == 'Kylla') ? true : false;
      $this->order_status = defined('MODULE_PAYMENT_LASKUHARI_ORDER_STATUS_ID') && ((int)MODULE_PAYMENT_LASKUHARI_ORDER_STATUS_ID > 0) ? (int)MODULE_PAYMENT_LASKUHARI_ORDER_STATUS_ID : 0;

      if ( $this->enabled === true ) {
        if ( isset($order) && is_object($order) ) {
          $this->update_status();
        }
      }
    }

    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_LASKUHARI_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_LASKUHARI_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }

      // disable the module if the order only contains virtual products (and such selected)
      if ($this->enabled == true && defined('MODULE_PAYMENT_LASKUHARI_VIRTUAL') && (MODULE_PAYMENT_LASKUHARI_VIRTUAL == 'Kylla')) {
        if ($order->content_type == 'virtual') {
          $this->enabled = false;
        }
      }

    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      global $order;
      return false;
    }

    function process_button() {
      return false;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      global $order;

      // create and send invoice here

      // laskunlähetyksen asetukset
      $laskuhari_uid = MODULE_PAYMENT_LASKUHARI_UID;
      $laskuhari_apikey = MODULE_PAYMENT_LASKUHARI_APIKEY;
      $sendername = MODULE_PAYMENT_LASKUHARI_SENDER;
      $email_message = ""; //todo
      if(trim(rtrim($email_message)) == "") {
        $email_message = "Hei,\n\nLiitteenä lasku tilauksestanne.";
      }

      // tilaajan tiedot
      $customer = $order->billing;

      // tilatut tuotteet
      $products = $order->products;

      // summat
      $loppusumma = $order->info["total"];
      $toimitustapa = $order->info["shipping_method"];
      $toimitusmaksu = $order->info["shipping_cost"];
      $toimitus_vero = 0;
      $alennus = 0;
      $cart_discount = 0;
      $cart_discount_tax = 0;

      // luodaan vahvistuskoodi rajapintaa varten
      $t = time();
      $digest_src = $laskuhari_uid."+".$t."+".$laskuhari_apikey;
      $cmd = "echo -n ".escapeshellarg($digest_src)." | shasum -a 256 -p";
      exec($cmd, $digest, $ret);
      $dt = substr($digest[0],0,64);
      unset($digest);

      // laskunluontirajapinnan URL
      $url = "https://oma.laskuhari.fi/api/invoice?uid=".$laskuhari_uid."&t=".$t."&dt=".$dt;
      $post  = "action=create";

      $post .=  '&maksuehto='.
            '&pvm='.date('d.m.Y').
            '&lahetetty=0'.
            '&yritys='.urlencode($customer['company']).
            '&henkilo='.urlencode($customer['firstname'].' '.$customer['lastname']).
            '&lahiosoite='.urlencode(trim($customer['street_address'])).
            '&postinumero='.urlencode($customer['postcode']).
            '&postitoimipaikka='.urlencode($customer['city']).
            '&email='.urlencode($customer['email']).
            '&ytunnus='.
            '&puhelin='.urlencode($customer['phone']).
            '&teksti=';

      $i = 1;
      $total = 0;
      foreach($products as $data) {
        $yks_veroton = $data['final_price'];
        $yks_verollinen = $yks_veroton * ((100+$data["tax"])/100);
        $yht_veroton = $yks_veroton * $data["qty"];
        $yht_verollinen = $yks_verollinen * $data["qty"];
        $alv = $data["tax"];
        $ale = ($data['price'] - $data['final_price']) / $data['price'] * 100;
        $ale = 0; //koska pyoristys menee sekaisin laskuharissa...

        $discount_amount = $ale / 100 * $yht_veroton;
        $cart_discount -= $discount_amount;
        $cart_discount_tax -= $alv / 100 * $discount_amount;

        //kommentoitu koska pyoristys menee sekaisin laskuharissa...
        //$yht_veroton = $yks_veroton * $data["qty"];
        //$yht_verollinen = $yks_verollinen * $data["qty"];
        
        $name = $data["name"];
        if($data["model"] != "") {
          $name .= " (".$data['name'].")";
        }

        $post .=  "&laskurivi[".$i."][tyyppi]=0".
              "&laskurivi[".$i."][koodi]=".
              "&laskurivi[".$i."][nimike]=".urlencode($name).
              "&laskurivi[".$i."][maara]=".urlencode($data['qty']).
              "&laskurivi[".$i."][yks]=".
              "&laskurivi[".$i."][veroton]=".$yks_veroton.
              "&laskurivi[".$i."][alv]=".$alv.
              "&laskurivi[".$i."][verollinen]=".$yks_verollinen.
              "&laskurivi[".$i."][ale]=".$ale.
              "&laskurivi[".$i."][yhtveroton]=".$yht_veroton.
              "&laskurivi[".$i."][yhtverollinen]=".$yht_verollinen.
              "&laskurivi[".$i."][toistovali]=0".
              "&laskurivi[".$i."][ennakko]=0".
              "&laskurivi[".$i."][jatkuvuus]=0".
              "&laskurivi[".$i."][automaatio]=0".
              "&laskurivi[".$i."][toistoale]=0";
        $total += $yht_verollinen;
        $i++;
      }

      // lisätään toimitusmaksu
      $toimitus_vero = $loppusumma - ($total+$toimitusmaksu); // lasketaan vero oscommercen loppusumman ja tuotteiden lasketun loppusumman erosta
      $toimitusalv = $toimitusmaksu != 0 ? $toimitus_vero/$toimitusmaksu*100 : 0;
      $post .=  "&laskurivi[".$i."][tyyppi]=0".
            "&laskurivi[".$i."][koodi]=".
            "&laskurivi[".$i."][nimike]=".urlencode("Toimitustapa: ".$toimitustapa).
            "&laskurivi[".$i."][maara]=1".
            "&laskurivi[".$i."][yks]=".
            "&laskurivi[".$i."][veroton]=".($toimitusmaksu).
            "&laskurivi[".$i."][alv]=".round($toimitusalv, 0).
            "&laskurivi[".$i."][verollinen]=".($toimitusmaksu+$toimitus_vero).
            "&laskurivi[".$i."][ale]=0".
            "&laskurivi[".$i."][yhtveroton]=".$toimitusmaksu.
            "&laskurivi[".$i."][yhtverollinen]=".($toimitusmaksu+$toimitus_vero).
            "&laskurivi[".$i."][toistovali]=0".
            "&laskurivi[".$i."][ennakko]=0".
            "&laskurivi[".$i."][jatkuvuus]=0".
            "&laskurivi[".$i."][automaatio]=0".
            "&laskurivi[".$i."][toistoale]=0";

      $i++;

      // lisätään alennus
      if($cart_discount > 0.009) {
        $post .=  "&laskurivi[".$i."][tyyppi]=0".
              "&laskurivi[".$i."][koodi]=".
              "&laskurivi[".$i."][nimike]=".urlencode("Alennus").
              "&laskurivi[".$i."][maara]=1".
              "&laskurivi[".$i."][yks]=".
              "&laskurivi[".$i."][veroton]=".($cart_discount*-1).
              "&laskurivi[".$i."][alv]=".round($cart_discount_tax/$cart_discount*100, 0).
              "&laskurivi[".$i."][verollinen]=".(($cart_discount+$cart_discount_tax)*-1).
              "&laskurivi[".$i."][ale]=0".
              "&laskurivi[".$i."][yhtveroton]=".($cart_discount*-1).
              "&laskurivi[".$i."][yhtverollinen]=".(($cart_discount+$cart_discount_tax)*-1).
              "&laskurivi[".$i."][toistovali]=0".
              "&laskurivi[".$i."][ennakko]=0".
              "&laskurivi[".$i."][jatkuvuus]=0".
              "&laskurivi[".$i."][automaatio]=0".
              "&laskurivi[".$i."][toistoale]=0";

        $i++;
      }

      // suoritetaan curl
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($ch, CURLOPT_URL, $url);
      curl_setopt($ch, CURLOPT_FAILONERROR, 1);
      curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
      curl_setopt($ch, CURLOPT_TIMEOUT, 100);
      curl_setopt($ch, CURLOPT_POST, TRUE);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
      $response = curl_exec($ch);

      // tarkastetaan virheet
      if(curl_errno($ch)) {
        return("ERROR");
        //curl_errno().curl_error()
      }
      if(stripos(".".$response, "error")) {
        return("ERROR");
        //error
      }

      curl_close($ch);

      $response = json_decode($response, true);
      $laskunro = $response['new_invoice_number'];

      // LASKUN LÄHETYS

      // luodaan POST-pyyntö
      $post  = "action=send";
      if($customer['email'] != "") {
        $sendername = $sendername ? $sendername : "Laskutus";

        $post .= "&invoiceType=email";
        $post .= "&eMailSenderName=".$sendername;
        $post .= "&receiverEmail=".urlencode($customer['email']);
        $post .= "&eMailSubject=Lasku";
        $post .= "&eMailMessage=".urlencode($email_message);
        $kirjelasku = false;
      } else {
        $kirjelasku = true;
        $post .= "&invoiceType=letter";
      }

      if(
        (MODULE_PAYMENT_LASKUHARI_SENDTYPE == "Kirje" && $kirjelasku == true) ||
        (MODULE_PAYMENT_LASKUHARI_SENDTYPE == "Sahkoposti" && $kirjelasku == false) ||
        (MODULE_PAYMENT_LASKUHARI_SENDTYPE == "Kirje, jos sahkopostia ei ole annettu")
      ) {

        // luodaan vahvistuskoodi rajapintaa varten
        $t = time();
        $digest_src = $laskuhari_uid."+".$t."+".$laskuhari_apikey;
        $cmd = "echo -n ".escapeshellarg($digest_src)." | shasum -a 256 -p";
        exec($cmd, $digest, $ret);
        $dt = substr($digest[0],0,64);
        unset($digest);

        // laskunlähetysrajapinnan URL
        $url = "https://oma.laskuhari.fi/api/invoice/".($laskunro*1)."?uid=".$laskuhari_uid."&t=".$t."&dt=".$dt;

        // suoritetaan curl
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_FAILONERROR, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 100);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
        $response = curl_exec($ch);

        // tarkastetaan virheet
        if(curl_errno($ch)) {
          return("AERROR");
          //curl_errno().curl_error()
        }
        if(stripos(".".$response, "error")) {
          return("BERROR");
          //error
        }

        curl_close($ch);

        $response = json_decode($response, true);

       // lahetettiin

      } else {
        // ei lahetetty
      }


      return false;
    }

    function get_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_LASKUHARI_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Ota Laskuhari-moduuli k&auml;ytt&ouml;n', 'MODULE_PAYMENT_LASKUHARI_STATUS', 'Kylla', 'Otetaanko laskulla maksaminen k&auml;ytt&ouml;&ouml;n?', '6', '1', 'tep_cfg_select_option(array(\'Kylla\', \'Ei\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Virtuaalituotteet', 'MODULE_PAYMENT_LASKUHARI_VIRTUAL', 'Ei', 'Virtuaalituotteita voi tilata laskulla', '6', '1', 'tep_cfg_select_option(array(\'Kylla\', \'Ei\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Laskutustapa', 'MODULE_PAYMENT_LASKUHARI_SENDTYPE', 'Sahkoposti', 'Miten laskut l&auml;hetet&auml;n?', '6', '1', 'tep_cfg_select_option(array(\'Sahkoposti\', \'Kirje\', \'Kirje, jos sahkopostia ei ole annettu\', \'Tallenna Laskuhariin, ei lahetysta\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('API-koodi', 'MODULE_PAYMENT_LASKUHARI_APIKEY', '', 'API-koodi todennusta varten', '6', '1', NULL, now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('UID', 'MODULE_PAYMENT_LASKUHARI_UID', '', 'UID tunnukseen liitt&auml;mist&auml; varten', '6', '1', NULL, now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Laskuttajan nimi', 'MODULE_PAYMENT_LASKUHARI_SENDER', '', 'L&auml;hett&auml;j&auml;n nimi s&auml;hk&ouml;postilaskussa', '6', '1', NULL, now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Maksualue', 'MODULE_PAYMENT_LASKUHARI_ZONE', '0', 'Jos valitset maksualueen, laskutus on valittavissa vain sille alueelle.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Tilauksen status', 'MODULE_PAYMENT_LASKUHARI_ORDER_STATUS_ID', '0', 'M&auml;rit&auml; laskulla tilattujen tilausten statukseksi t&auml;m&auml;', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
   }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_LASKUHARI_STATUS', 'MODULE_PAYMENT_LASKUHARI_ZONE', 'MODULE_PAYMENT_LASKUHARI_ORDER_STATUS_ID', 'MODULE_PAYMENT_LASKUHARI_VIRTUAL', 'MODULE_PAYMENT_LASKUHARI_APIKEY', 'MODULE_PAYMENT_LASKUHARI_UID', 'MODULE_PAYMENT_LASKUHARI_SENDTYPE', 'MODULE_PAYMENT_LASKUHARI_SENDER');
    }
  }
?>
